// #name = TCMS (The-Construct Master/Auth Serv)
// #version = A.2
// #date = 19th November 2007
// #description = A script to query servers off the web.  Also includes auth system (Requires forum account)
// #category = Support
// #author = Krash123
// #warrior = Krash123
// #email = krash@raptorhideout.com
// #web = http://www.the-construct.net/forums/
// #readme = tcmsreadme.txt

//================================================================
// This file should contain pretty much everything that's needed.
// For now it's just the basics; Auth and such  It's pretty
// straightforward stuff in here, so it shouldn't need much
// explanation...  If any.  Free apples.
if ($Host::TCbeat == "") $Host::TCbeat = 15; //Time between beats in minutes.
if ($Host::TCauth == "") $Host::TCauth = 0; //Enable the auth system.
if ($Host::TCecho == "") $Host::TCecho = 1; //Enable the MS echoes.
if ($Host::TConln == "") $Host::TConln = 0; //Enable the MS queries in online mode.
package AuthTC {
//  Basic auth system.  Queries forum database for matching users.
//================================================================
function chatMessageAll( %sender, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10 ) {
      if(getSubStr(%a2, 0, 1) $= "/" && $Host::TCauth && !$PlayingOnline){
        %cmd=stripChars(getWord(%a2,0),"/");
        switch$ (%cmd){
           case "auth":
               TCAuthClient(%sender,"code",getWords(%a2,1));
               return;
        }
      }
   Parent::chatMessageAll( %sender, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10 );
}
function CreateServer(%mission, %missionType) {
   Parent::CreateServer(%mission, %missionType);
   if (!$PlayingOnline) TCHeartbeat($Host::Port);
}
function DestroyServer() {
   if(isEventPending($TNBeat)) cancel($TNBeat);
   Parent::DestroyServer();
}
function TCHeartBeat(%port) {
    if ($PlayingOnline) return;
    if(isEventPending($TCBeat)) cancel($TCBeat);
    %server = "www.the-construct.net:80";
    %path = "/tc/list/add/" @ %port @"/";
    if (!isObject(AuthTCbite))
      %bite = new HTTPObject(AuthTCbite){};
    else %bite = AuthTCbite;
      %bite.get(%server, %path);
    if ($Host::TCecho)
      echo("-- Sent heartbeat to TC Master. ("@%server@")");
    $TCBeat = schedule($Host::TCbeat*60000,0,"TCHeartbeat",$Host::Port);
}
function TCAuthClient(%client,%type,%args) {
if ($PlayingOnline) return;
//Smack my server up
  %type = %type @ "/";
  %script = "/auth/" @ %type;
  if (!%args){
    %param = %client.getAddress();
    %pos = strstr( %param, ":" );
    %param = getSubStr( %param, %pos + 1, strlen(%param) );
    %pos = strstr( %param, ":" );
    %param = getSubStr( %param, 0, %pos );
  } else %param = %args;
  %param = %param @"_"@ %client;
  %server = "www.the-construct.net:80";
  %filename = %script @ %param @ "/";
  if (!isObject(AuthTCbite))
     %bite = new HTTPObject(AuthTCbite){};
  else %bite = AuthTCbite;
  %bite.get(%server, %filename);

}

function AuthTCbite::onLine(%this, %line)
{
   %client = getSubStr( getWord(%line,1), strstr( getWord(%line,1), "_" ) +1, strlen(getWord(%line,1)));
   switch$ (%line) {
      case 0:  if ($Host::TCecho) echo(" - Server added to list.");
      case 1:  if ($Host::TCecho) { echo(" - Server could not be contacted.");
                                    echo(" - Check your IP / port configuration."); }
      case 2:  if ($Host::TCecho) echo(" - Server already found on list.");

      default:
        if (getWordCount(%line) != 3) return;
        if(%client.isAuthed) {messageclient(%client, 'MsgClient', "\c2You are already logged in to the TC Auth system."); return;}

        if(getSubStr(%line, 0, 3) $= "0 0"){
          messageclient(%client, 'MsgClient', "\c2TC Auth did not find an account matching your request. If you have an account, please use \c1/auth code\c2 with your unique code.  If not, you may need to register at \c1http://www.the-construct.net/forums/");
          messageclient(%client, 'MsgClient', "\c2(Your code can be found at \c1http://www.the-construct.net/forums/ \c2after a post)");
          return;
        }
        if(getSubStr(%line, 0, 3) $= "M M"){
          messageclient(%client, 'MsgClient', "\c2TC Auth found multiple accounts matching your address. Please use \c1/auth [code]\c2 with your unique code to ident and retrieve status.");
          return;
        }
      
      
        %guid = getSubStr(getWord(%line,1), 0, strstr( getWord(%line,1), "_" ) );
        if (%guid == 20 || %guid $= ""){
          %guid = getSubStr(getWord(%line,0), 4, strlen(getWord(%line,0)));
          %guid = %guid + 100000;
          %guid = getSubStr(%guid, 1, strlen(%guid));
          %guid = "0."@%guid;
        }
        if(getSubStr(%line, 0, 4) $= "Code") {
          TCRevoClient(%client,getWords(%line,2),%guid,1);
          messageclient(%client, 'MsgClient', "\c2TC Auth has logged you in as \c1"@getWords(%line,2)@"\c2 with GUID: \c1"@%guid@".");
        }
        else {
          TCRevoClient(%client,getWords(%line,2),%guid,0);
          messageclient(%client, 'MsgClient', "\c2TC Auth has changed your name to \c1" @ getWords(%line,2) @"\c2. Please use \c1/auth [code]\c2 with your unique code to ident and retrieve status.");
        }
   }
}
function TCRevoClient(%client,%name,%guid,%iscode){
  if ($PlayingOnline) return;
   %client.oldName = %client.name;
   %client.namebase = %name;
   %name = "\cp\c6" @ %name @ "\co";
   MessageAll( 'MsgClientNameChanged', "", %client.name, %name, %client );
   removeTaggedString(%client.name);
   %client.name = addTaggedString(%name);
   setTargetName(%client.target, %client.name);
   %client.isSmurf = "";

   if (!%iscode){ return;
   } else {
     %client.guid = %guid;
     %client.isAuthed = true;
     %client.sendGuid = %client.guid;

	   if ( !%client.isSuperAdmin )
	   {
	      if ( isOnSuperAdminList( %client ) )
	      {
	         %client.isAdmin = true;
	         %client.isSuperAdmin = true;
             MessageAll( 'MsgSuperAdminPlayer', "", %client);

	      }
	      else if ( isOnAdminList( %client ) )
	      {
	         %client.isAdmin = true;
             MessageAll( 'MsgAdminAdminPlayer', "", %client);
	      }
       }
   }

}
function AuthTCbite::onConnectFailed()
{
    echo("Could not connect to auth server. Blast!");
}
function AuthTCbite::onDisconnect(%this)
{
    %this.delete();
}



function GameConnection::onConnect( %client, %name, %raceGender, %skin, %voice, %voicePitch ){
    Parent::onConnect( %client, %name, %raceGender, %skin, %voice, %voicePitch );
    if ($Host::TCauth && !$PlayingOnline) TCAuthClient(%client,"ip");
}

function queryTCServers() {
    %filename = "/tc/list/TC-ServerList.cs";
    %server = "www.the-construct.net:80";
    if (!isObject(TCbite))
      %bite = new HTTPObject(TCbite){};
    else %bite = TCbite;
    %bite.get(%server, %filename);
}
function TCbite::onLine(%this, %line)
{
         if ((strpos(%line,"$pref::GameServerCount") != -1)) {
           //Nothing for now. Maybe later.
         } else if ((strpos(%line,"//EOF") != -1)) {
           %this.disconnect();
         } else {
           %server = getSubStr(getWord(%line,2), 1, strlen(getWord(%line,2))-3 );
           querySingleServer( %server );
         }
}
function TCbite::onConnectFailed()
{
   echo("Could not connect to master server. Blast!");
}
function TCbite::onDisconnect(%this)
{
   %this.delete();
}
function GMJ_Browser::clearList( %this )
{
   Parent::clearList( %this );
   if ( %this.lastQuery $= "LanServers" || $Host::TConln) queryTCServers();
}

};
if ( !isActivePackage(AuthTC) )
   activatepackage (AuthTC);
